#include "inland_config.h"
!-----------------------------------------------------------------------
subroutine fire
 !-----------------------------------------------------------------------
      use inland_ibispar
      use inland_comveg

      implicit none
!-----------------------------------------------------------------------
! local variables
      integer i
      real*8 burn

! begin global grid
      do 100 i = lbeg, lend
         burn = firefac(i) * min (dble(1.0), totlit(i) / 0.200)
         disturbf(i) = 1.0 - exp(-0.5 * burn)
         disturbf(i) = max (dble(0.0), min (dble(1.0), disturbf(i)))
100   continue
      return
end subroutine fire
