#include "inland_config.h"
! Provenient from math.f from SAGE's IBIS.
real function ran2(idum,idum2,iv,iy)
      use inland_ibisparm, only: ran2val
      implicit none
      integer idum,im1,im2,imm1,ia1,ia2,iq1,iq2,ir1,ir2,ntab,ndiv
      real am, eps, rnmx
      parameter (im1=2147483563,   &
                 im2=2147483399,   &
                 am=1./im1,        &
                 imm1=im1-1,       &
                 ia1=40014,        &
                 ia2=40692,        &
                 iq1=53668,        &
                 iq2=52774,        &
                 ir1=12211,        &
                 ir2=3791,         &
                 ntab=32,          &
                 ndiv=1+imm1/ntab, &
                 eps=1.0e-7,       &
                 rnmx=1.-eps)

      integer idum2,j,k,iv(ntab),iy

      if ( ran2val .ne. 0. ) then
         ran2=ran2val
         return
      end if

      if (idum.le.0) then
         idum=max(-idum,1)
         idum2=idum
         do 10 j=ntab+8,1,-1
            k=idum/iq1
            idum=ia1*(idum-k*iq1)-k*ir1
            if (idum.lt.0) idum=idum+im1
            if (j.le.ntab) iv(j)=idum
10       continue
         iy=iv(1)
      endif

      k=idum/iq1
      idum=ia1*(idum-k*iq1)-k*ir1
      if (idum.lt.0) idum=idum+im1

      k=idum2/iq2
      idum2=ia2*(idum2-k*iq2)-k*ir2
      if (idum2.lt.0) idum2=idum2+im2

      j=1+iy/ndiv
      iy=iv(j)-idum2
      iv(j)=idum
      if(iy.lt.1)iy=iy+imm1

      ran2=min(am*iy,rnmx)
      return
end function ran2
